<?php

namespace Drupal\user_cancel_methods_permissions;

use Drupal\Core\Render\Element;
use Drupal\Core\StringTranslation\StringTranslationTrait;

/**
 * Implements PermissionGenerator class.
 */
class PermissionGenerator {

  use StringTranslationTrait;

  /**
   * Returns an array of permissions.
   *
   * @return array
   *   An array of permissions for permission_callbacks.
   */
  public function permissions(): array {
    $permissions = [];

    $form = user_cancel_methods();
    foreach (Element::children($form) as $name) {
      $permissions[sprintf('allow user cancel method %s', $name)] = [
        'title' => $this->t('Allow to use user cancel method: %name', ['%name' => $name]),
        'description' => $form['#options'][$name],
      ];
    }

    return $permissions;
  }

}
